=== debian/changelog ===
hypridle (0.1.7-1) unstable; urgency=medium

  * Initial release. (Closes: #1099510)

 -- Carl Keinath <carl.keinath@gmail.com>  Thu, 18 Sep 2025 15:37:52 +0200
